(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_index.mli,v 1.4 2013-07-02 16:58:46 fclement Exp $*)

(** {3 The type of matrix indices} *)

type element = Unatural.t * Unatural.t;;
type index = element Uindex.t;;

val to_index : Unatural.t -> index;;
val of_index : index -> Unatural.t;;

val of_natural : Unatural.t -> index;;
val to_natural : index -> Unatural.t;;

val of_int : int -> index;;
val to_int : index -> int;;

val _0_ : index;;
val _1_ : index;;

val succ : index -> index;;
val pred : index -> index;;
