(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: hashtbl_print.ml,v 1.4 2014/01/10 15:28:05 fclement Exp $ *)

let print_statistics ppf = function
  | {
      Hashtbl.num_bindings = i;
      num_buckets = i0;
      max_bucket_length = i1;
      bucket_histogram = i_a;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>num_bindings =@ ";
    Lib_print.print_quoted_int ppf i; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>num_buckets =@ ";
    Lib_print.print_quoted_int ppf i0; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>max_bucket_length =@ ";
    Lib_print.print_quoted_int ppf i1; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>bucket_histogram =@ ";
    Lib_print.print_Array Lib_print.print_quoted_int ppf i_a;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;
