(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uarray2_with_c_layout.mli,v 1.11 2014/01/10 15:28:04 fclement Exp $ *)

(** {3 More operations on two-dimensional bigarrays with C layout} *)

open Bigarray;;

(** {6 Iterators} *)

val iter : ('a -> unit) -> ('a, 'b, c_layout) Array2.t -> unit;;
(** [iter f a] applies function [f] in turn to all the
    elements of the bigarray [a]. *)

val iterij : (int -> int -> 'a -> unit) -> ('a, 'b, c_layout) Array2.t -> unit;;
(** Same as {!iter}, but the function is applied to the
    indices of the element as first and second arguments, and the element itself
    as third argument. *)
