(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mapping.mli,v 1.1 2013/06/13 19:01:17 fclement Exp $ *)

open Mapping_types;;

(*
val extensional_mapping_digest :
  ('a, 'b, ('a, 'b) extensional_mapping) Utype_digest.lifter2
;;

val intensional_mapping_digest :
  ('a, 'b, ('a, 'b) intensional_mapping) Utype_digest.lifter2
;;

val intensional_structural_mapping_digest :
  ('a, 'b, ('a, 'b) intensional_structural_mapping) Utype_digest.lifter2
;;

val extensional_structural_mapping_digest :
  ('a, 'b, ('a, 'b) extensional_structural_mapping) Utype_digest.lifter2
;;
*)

val sub_extensional_mapping :
  ('a, 'b) extensional_mapping -> 'a Uset.subset ->
  ('a, 'b) extensional_mapping
;;
(** [sub_extensional_mapping em dom] return the restriction of [em] to [dom].
 *)

val extensional_mapping_map :
  ('a -> 'b) -> ('c, 'a) extensional_mapping -> ('c, 'b) extensional_mapping
;;

(*
val extensional_mapping_map :
  ('a -> 'c) -> ('b -> 'd) ->
  ('a, 'b) extensional_mapping -> ('c, 'd) extensional_mapping
;;
*)

(** {6 Converters} *)

val intensional_mapping_of_extensional_mapping :
  ('a, 'b) extensional_mapping -> ('a, 'b) intensional_mapping
;;

val extensional_mapping_of_intensional_mapping :
  ('a, 'b) intensional_mapping -> ('a, 'b) extensional_mapping
;;

val extensional_mapping_of_intensional_structural_mapping :
  ('a, 'b) intensional_structural_mapping -> ('a, 'b) extensional_mapping
;;

val intensional_mapping_of_intensional_structural_mapping :
  ('a, 'b) intensional_structural_mapping -> ('a, 'b) intensional_mapping
;;

val intensional_structural_mapping_of_extensional_mapping :
  ('a, 'b) extensional_mapping -> ('a, 'b) intensional_structural_mapping
;;

val intensional_structural_mapping_of_intensional_mapping :
  ('a, 'b) intensional_mapping -> ('a, 'b) intensional_structural_mapping
;;

val extensional_mapping_of_extensional_structural_mapping :
  ('a, 'b) extensional_structural_mapping -> ('a, 'b) extensional_mapping
;;

val extensional_structural_mapping_of_extensional_mapping :
  ('a, 'b) extensional_mapping -> ('a, 'b) extensional_structural_mapping
;;

(** {6 Iterators} *)

val intensional_structural_mapping_fold_left :
  ('accu -> ('a, 'b) intensional_mapping_location ->
    ('a, 'b) intensional_mapping -> 'accu) ->
  'accu -> ('a, 'b) intensional_structural_mapping -> 'accu
;;

val intensional_structural_mapping_map :
  (('a, 'b) intensional_mapping -> ('c, 'd) intensional_mapping) ->
  ('a, 'b) intensional_structural_mapping ->
  ('c, 'd) intensional_structural_mapping
;;

val extensional_structural_mapping_fold_left :
  ('accu -> ('a, 'b) extensional_mapping_location ->
    ('a, 'b) extensional_mapping -> 'accu) ->
  'accu -> ('a, 'b) extensional_mapping_location -> 'accu
;;

val extensional_structural_mapping_map :
  (('a, 'b) extensional_mapping -> ('c, 'd) extensional_mapping) ->
  ('a, 'b) extensional_structural_mapping ->
  ('c, 'd) extensional_structural_mapping
;;
